#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define	STARTX		100
#define STARTY		100
#define NODESX		201
#define READFILE	"nodes.txt"
#define WRITEFILE	"depth_distance.txt"
#define SCALE		5
#define MAXCHS		800
#define MAXDEPTH	26 //0 to 20

typedef struct
{
	int NID;
	int depth;
	double dis;
} node;


int main()
{
	FILE *fp_read, *fp_write, *fp_depth;
	char str[100], str2[50];
	unsigned int nid, cid, ch_nid, parent_ch_nid, no_child_nodes, no_bcasts, no_acks, x, y;       
	unsigned char depth;
	double distance;
	int ret_val, no_CHs, max_depth, i, j;
	node nodes[MAXCHS];
	int distance_CHs[MAXDEPTH][101];

	for(i = 0; i < MAXDEPTH; i++)
	{
		for(j = 0; j < 101 ; j++)
		{
			distance_CHs[i][j] = 0;
		}
	}


	no_CHs = 0;
	max_depth = 0;

        fp_read = fopen(READFILE, "r");
        if(fp_read == NULL)
        {
                perror("ERROR:");
                exit(1);
        }

        fp_write = fopen(WRITEFILE, "w");
        if(fp_write == NULL)
        {
                perror("ERROR:");
                exit(1);
        }

        while(fgets(str, 100, fp_read) != NULL)
        {
                sscanf(str, "%d %d %d %d %d %d %d %d", &nid, &cid, &ch_nid, &parent_ch_nid, &depth, &no_child_nodes, &no_bcasts, &no_acks);
		if((nid != 0) && (nid == ch_nid))	//If it's a CH
		{	
			x = (nid - 1) % NODESX;
			y = (nid - 1) / NODESX;

			distance = sqrt(( ( SCALE * x - SCALE * STARTX) * (SCALE * x - SCALE * STARTX)) + ((SCALE * y - SCALE * STARTY)*(SCALE * y - SCALE * STARTY)));
			nodes[no_CHs].NID = nid;
			nodes[no_CHs].depth = depth;
			nodes[no_CHs].dis = distance;
			no_CHs++;	
			if(depth > max_depth)
				max_depth = depth;
			ret_val = sprintf(str2, "%f\t%d\n", distance, depth);
			fputs(str2, fp_write);
		}
        }

        fclose(fp_read);
        fclose(fp_write);

	for(j = 0; j < no_CHs; j++)
	{
		if((nodes[j].dis >= 0) &&(nodes[j].dis < 5))
			distance_CHs[nodes[j].depth][0]++; 
		else if((nodes[j].dis >= 5) &&(nodes[j].dis < 10))
			distance_CHs[nodes[j].depth][1]++; 
		else if((nodes[j].dis >= 10) &&(nodes[j].dis < 15))
			distance_CHs[nodes[j].depth][2]++; 
		else if((nodes[j].dis >= 15) &&(nodes[j].dis < 20))
			distance_CHs[nodes[j].depth][3]++; 
		else if((nodes[j].dis >= 20) &&(nodes[j].dis < 25))
			distance_CHs[nodes[j].depth][4]++; 
		else if((nodes[j].dis >= 25) &&(nodes[j].dis < 30))
			distance_CHs[nodes[j].depth][5]++; 
		else if((nodes[j].dis >= 30) &&(nodes[j].dis < 35))
			distance_CHs[nodes[j].depth][6]++; 
		else if((nodes[j].dis >= 35) &&(nodes[j].dis < 40))
			distance_CHs[nodes[j].depth][7]++; 
		else if((nodes[j].dis >= 40) &&(nodes[j].dis < 45))
			distance_CHs[nodes[j].depth][8]++; 
		else if((nodes[j].dis >= 45) &&(nodes[j].dis < 50))
			distance_CHs[nodes[j].depth][9]++; 
		else if((nodes[j].dis >= 50) &&(nodes[j].dis < 55))
			distance_CHs[nodes[j].depth][10]++; 
		else if((nodes[j].dis >= 55) &&(nodes[j].dis < 60))
			distance_CHs[nodes[j].depth][11]++; 
		else if((nodes[j].dis >= 60) &&(nodes[j].dis < 65))
			distance_CHs[nodes[j].depth][12]++; 
		else if((nodes[j].dis >= 65) &&(nodes[j].dis < 70))
			distance_CHs[nodes[j].depth][13]++; 
		else if((nodes[j].dis >= 70) &&(nodes[j].dis < 75))
			distance_CHs[nodes[j].depth][14]++; 
		else if((nodes[j].dis >= 75) &&(nodes[j].dis < 80))
			distance_CHs[nodes[j].depth][15]++; 
		else if((nodes[j].dis >= 80) &&(nodes[j].dis < 85))
			distance_CHs[nodes[j].depth][16]++; 
		else if((nodes[j].dis >= 85) &&(nodes[j].dis < 90))
			distance_CHs[nodes[j].depth][17]++; 
		else if((nodes[j].dis >= 90) &&(nodes[j].dis < 95))
			distance_CHs[nodes[j].depth][18]++; 
		else if((nodes[j].dis >= 95) &&(nodes[j].dis < 100))
			distance_CHs[nodes[j].depth][19]++; 
		else if((nodes[j].dis >= 100) &&(nodes[j].dis < 105))
			distance_CHs[nodes[j].depth][20]++; 
		else if((nodes[j].dis >= 105) &&(nodes[j].dis < 110))
			distance_CHs[nodes[j].depth][21]++; 
		else if((nodes[j].dis >= 110) &&(nodes[j].dis < 115))
			distance_CHs[nodes[j].depth][22]++; 
		else if((nodes[j].dis >= 115) &&(nodes[j].dis < 120))
			distance_CHs[nodes[j].depth][23]++; 
		else if((nodes[j].dis >= 120) &&(nodes[j].dis < 125))
			distance_CHs[nodes[j].depth][24]++; 
		else if((nodes[j].dis >= 125) &&(nodes[j].dis < 130))
			distance_CHs[nodes[j].depth][25]++; 
		else if((nodes[j].dis >= 130) &&(nodes[j].dis < 135))
			distance_CHs[nodes[j].depth][26]++; 
		else if((nodes[j].dis >= 135) &&(nodes[j].dis < 140))
			distance_CHs[nodes[j].depth][27]++; 
		else if((nodes[j].dis >= 140) &&(nodes[j].dis < 145))
			distance_CHs[nodes[j].depth][28]++; 
		else if((nodes[j].dis >= 145) &&(nodes[j].dis < 150))
			distance_CHs[nodes[j].depth][29]++; 
		else if((nodes[j].dis >= 150) &&(nodes[j].dis < 155))
			distance_CHs[nodes[j].depth][30]++; 
		else if((nodes[j].dis >= 155) &&(nodes[j].dis < 160))
			distance_CHs[nodes[j].depth][31]++; 
		else if((nodes[j].dis >= 160) &&(nodes[j].dis < 165))
			distance_CHs[nodes[j].depth][32]++; 
		else if((nodes[j].dis >= 165) &&(nodes[j].dis < 170))
			distance_CHs[nodes[j].depth][33]++; 
		else if((nodes[j].dis >= 170) &&(nodes[j].dis < 175))
			distance_CHs[nodes[j].depth][34]++; 
		else if((nodes[j].dis >= 175) &&(nodes[j].dis < 180))
			distance_CHs[nodes[j].depth][35]++; 
		else if((nodes[j].dis >= 180) &&(nodes[j].dis < 185))
			distance_CHs[nodes[j].depth][36]++; 
		else if((nodes[j].dis >= 185) &&(nodes[j].dis < 190))
			distance_CHs[nodes[j].depth][37]++; 
		else if((nodes[j].dis >= 190) &&(nodes[j].dis < 195))
			distance_CHs[nodes[j].depth][38]++; 
		else if((nodes[j].dis >= 195) &&(nodes[j].dis < 200))
			distance_CHs[nodes[j].depth][39]++; 
		else if((nodes[j].dis >= 200) &&(nodes[j].dis < 205))
			distance_CHs[nodes[j].depth][40]++; 
		else if((nodes[j].dis >= 205) &&(nodes[j].dis < 210))
			distance_CHs[nodes[j].depth][41]++; 
		else if((nodes[j].dis >= 210) &&(nodes[j].dis < 215))
			distance_CHs[nodes[j].depth][42]++; 
		else if((nodes[j].dis >= 215) &&(nodes[j].dis < 220))
			distance_CHs[nodes[j].depth][43]++; 
		else if((nodes[j].dis >= 220) &&(nodes[j].dis < 225))
			distance_CHs[nodes[j].depth][44]++; 
		else if((nodes[j].dis >= 225) &&(nodes[j].dis < 230))
			distance_CHs[nodes[j].depth][45]++;
		else if((nodes[j].dis >= 230) &&(nodes[j].dis < 235))
			distance_CHs[nodes[j].depth][46]++; 
		else if((nodes[j].dis >= 235) &&(nodes[j].dis < 240))
			distance_CHs[nodes[j].depth][47]++; 
		else if((nodes[j].dis >= 240) &&(nodes[j].dis < 245))
			distance_CHs[nodes[j].depth][48]++; 
		else if((nodes[j].dis >= 245) &&(nodes[j].dis < 250))
			distance_CHs[nodes[j].depth][49]++; 
		else if((nodes[j].dis >= 250) &&(nodes[j].dis < 255))
			distance_CHs[nodes[j].depth][50]++; 
		else if((nodes[j].dis >= 255) &&(nodes[j].dis < 260))
			distance_CHs[nodes[j].depth][51]++; 
		else if((nodes[j].dis >= 260) &&(nodes[j].dis < 265))
			distance_CHs[nodes[j].depth][52]++; 
		else if((nodes[j].dis >= 265) &&(nodes[j].dis < 270))
			distance_CHs[nodes[j].depth][53]++; 
		else if((nodes[j].dis >= 270) &&(nodes[j].dis < 275))
			distance_CHs[nodes[j].depth][54]++; 
		else if((nodes[j].dis >= 275) &&(nodes[j].dis < 280))
			distance_CHs[nodes[j].depth][55]++;
		else if((nodes[j].dis >= 280) &&(nodes[j].dis < 285))
			distance_CHs[nodes[j].depth][56]++; 
		else if((nodes[j].dis >= 285) &&(nodes[j].dis < 290))
			distance_CHs[nodes[j].depth][57]++; 
		else if((nodes[j].dis >= 290) &&(nodes[j].dis < 295))
			distance_CHs[nodes[j].depth][58]++; 
		else if((nodes[j].dis >= 295) &&(nodes[j].dis < 300))
			distance_CHs[nodes[j].depth][59]++; 
		else if((nodes[j].dis >= 300) &&(nodes[j].dis < 305))
			distance_CHs[nodes[j].depth][60]++; 
		else if((nodes[j].dis >= 305) &&(nodes[j].dis < 310))
			distance_CHs[nodes[j].depth][61]++; 
		else if((nodes[j].dis >= 310) &&(nodes[j].dis < 315))
			distance_CHs[nodes[j].depth][62]++; 
		else if((nodes[j].dis >= 315) &&(nodes[j].dis < 320))
			distance_CHs[nodes[j].depth][63]++; 
		else if((nodes[j].dis >= 320) &&(nodes[j].dis < 325))
			distance_CHs[nodes[j].depth][64]++; 
		else if((nodes[j].dis >= 325) &&(nodes[j].dis < 330))
			distance_CHs[nodes[j].depth][65]++;
		else if((nodes[j].dis >= 330) &&(nodes[j].dis < 335))
			distance_CHs[nodes[j].depth][66]++; 
		else if((nodes[j].dis >= 335) &&(nodes[j].dis < 340))
			distance_CHs[nodes[j].depth][67]++; 
		else if((nodes[j].dis >= 340) &&(nodes[j].dis < 345))
			distance_CHs[nodes[j].depth][68]++; 
		else if((nodes[j].dis >= 345) &&(nodes[j].dis < 350))
			distance_CHs[nodes[j].depth][69]++; 
		else if((nodes[j].dis >= 350) &&(nodes[j].dis < 355))
			distance_CHs[nodes[j].depth][70]++; 
		else if((nodes[j].dis >= 355) &&(nodes[j].dis < 360))
			distance_CHs[nodes[j].depth][71]++; 
		else if((nodes[j].dis >= 360) &&(nodes[j].dis < 365))
			distance_CHs[nodes[j].depth][72]++; 
		else if((nodes[j].dis >= 365) &&(nodes[j].dis < 370))
			distance_CHs[nodes[j].depth][73]++; 
		else if((nodes[j].dis >= 370) &&(nodes[j].dis < 375))
			distance_CHs[nodes[j].depth][74]++; 
		else if((nodes[j].dis >= 375) &&(nodes[j].dis < 380))
			distance_CHs[nodes[j].depth][75]++;
		else if((nodes[j].dis >= 380) &&(nodes[j].dis < 385))
			distance_CHs[nodes[j].depth][76]++; 
		else if((nodes[j].dis >= 385) &&(nodes[j].dis < 390))
			distance_CHs[nodes[j].depth][77]++; 
		else if((nodes[j].dis >= 390) &&(nodes[j].dis < 395))
			distance_CHs[nodes[j].depth][78]++; 
		else if((nodes[j].dis >= 395) &&(nodes[j].dis < 400))
			distance_CHs[nodes[j].depth][79]++; 
		else if((nodes[j].dis >= 400) &&(nodes[j].dis < 405))
			distance_CHs[nodes[j].depth][80]++; 
		else if((nodes[j].dis >= 405) &&(nodes[j].dis < 410))
			distance_CHs[nodes[j].depth][81]++; 
		else if((nodes[j].dis >= 410) &&(nodes[j].dis < 415))
			distance_CHs[nodes[j].depth][82]++; 
		else if((nodes[j].dis >= 415) &&(nodes[j].dis < 420))
			distance_CHs[nodes[j].depth][83]++; 
		else if((nodes[j].dis >= 420) &&(nodes[j].dis < 425))
			distance_CHs[nodes[j].depth][84]++; 
		else if((nodes[j].dis >= 425) &&(nodes[j].dis < 430))
			distance_CHs[nodes[j].depth][85]++;
		else if((nodes[j].dis >= 430) &&(nodes[j].dis < 435))
			distance_CHs[nodes[j].depth][86]++; 
		else if((nodes[j].dis >= 435) &&(nodes[j].dis < 440))
			distance_CHs[nodes[j].depth][87]++; 
		else if((nodes[j].dis >= 440) &&(nodes[j].dis < 445))
			distance_CHs[nodes[j].depth][88]++; 
		else if((nodes[j].dis >= 445) &&(nodes[j].dis < 450))
			distance_CHs[nodes[j].depth][89]++; 
		else if((nodes[j].dis >= 450) &&(nodes[j].dis < 455))
			distance_CHs[nodes[j].depth][90]++; 
		else if((nodes[j].dis >= 455) &&(nodes[j].dis < 460))
			distance_CHs[nodes[j].depth][91]++; 
		else if((nodes[j].dis >= 460) &&(nodes[j].dis < 465))
			distance_CHs[nodes[j].depth][92]++; 
		else if((nodes[j].dis >= 465) &&(nodes[j].dis < 470))
			distance_CHs[nodes[j].depth][93]++; 
		else if((nodes[j].dis >= 470) &&(nodes[j].dis < 475))
			distance_CHs[nodes[j].depth][94]++; 
		else if((nodes[j].dis >= 475) &&(nodes[j].dis < 480))
			distance_CHs[nodes[j].depth][95]++;
		else if((nodes[j].dis >= 480) &&(nodes[j].dis < 485))
			distance_CHs[nodes[j].depth][96]++; 
		else if((nodes[j].dis >= 485) &&(nodes[j].dis < 490))
			distance_CHs[nodes[j].depth][97]++; 
		else if((nodes[j].dis >= 490) &&(nodes[j].dis < 495))
			distance_CHs[nodes[j].depth][98]++; 
		else if((nodes[j].dis >= 495) &&(nodes[j].dis < 500))
			distance_CHs[nodes[j].depth][99]++; 
		else
			distance_CHs[nodes[j].depth][100]++;
	}
	for(j = 0; j <= max_depth; j++)
	{
        	ret_val = sprintf(str, "depth%d.txt", j);
		fp_depth = fopen(str, "a");
	        if(fp_depth == NULL)
        	{
                	perror("ERROR:");
	                exit(1);
        	}

		for(i = 0; i < 101; i++)
		{
			if( i < 100)
				ret_val = sprintf(str2, "%d\t", distance_CHs[j][i]);
			else
				ret_val = sprintf(str2, "%d\n", distance_CHs[j][i]);
			fputs(str2, fp_depth);
		}

		fclose(fp_depth);
	}
	return 0;
}

